from Interface import Interface
from Interface.Attribute import Attribute

class ILayer(Interface):
    def initalizeInstance(instance):
        """optionally called to initalize a layer for an entire
        instance"""

    def initalizeField(instance, field):
        """optionally called to inistalize a layer for a given field"""



class ILayerContainer(Interface):
    """An object that contains layers and can use/manipulate them"""

    def registerLayer(name, object):
        """Register an object as providing a new layer under a given
        name"""

    def registeredLayers():
        """Provides a list of (name, object) layer pairs"""


class ILayerRuntime(Interface):
    def initalizeLayers(instance):
        """optional Process all layers attempting their initalizeInstance and
        initalizeField methods if they exist.
        """

