from Products.CMFTypes import registerType
from Products.CMFTypes.BaseContent import BaseContent
from Products.CMFTypes.ExtensibleMetadata import ExtensibleMetadata
from Products.CMFTypes.Field       import *
from Products.CMFTypes.Form        import *
from Products.CMFTypes.debug import log

def addArticle(self, id, **kwargs):
    o = Article(id, **kwargs)
    self._setObject(id, o)


content_type = BaseContent.type + ExtensibleMetadata.type +  FieldList((
    ObjectField( 'blurb'
                 , searchable=1
                 , required=0
                 , form_info=TextAreaInfo(description="Enter a blurb for this article"
                                        ,label="Blurb"
                                        ))
    , TextField('body'
                , searchable=1
                , required=1
                , allowable_content_types=('text/plain',
                                         'text/structured',
                                         'text/html',)
                , form_info=RichFormInfo(description="The article content."
                                         ,label="Content"
                                         ))
    , ObjectField( 'secret'
                   , required=1
                   , form_info=PasswordInfo(description="ssssh"
                                            ,label="passwd"))
    ))

class Article(BaseContent):
    portal_type = meta_type = "Article"
    type = content_type


registerType(Article)
