import docutils.core, docutils.io
from ContentDriver import ContentDriver
from Products.CMFTypes.debug import log

class Warnings:
    def __init__(self):
        self.messages = []

    def write(self, message):
        self.messages.append(message)

class Converter(ContentDriver):
  mime_type = 'text/restructured' 

  def convertData(self, instance, data):
      # format with strings
      from html4zope import Writer
      pub = docutils.core.Publisher(writer=Writer())
      pub.set_reader('standalone', None, 'restructuredtext')
      
      # go with the defaults
      pub.get_settings()
      
      # this is needed, but doesn't seem to do anything
      pub.settings._destination = ''
      
      # use the stylesheet chosen by the user
      #pub.settings.stylesheet = 'plone.css'
      
      # set the reporting level to something sane
      pub.settings.report_level = 1
      
      # don't break if we get errors
      pub.settings.halt_level = 6

      # remember warnings
      pub.settings.warning_stream = Warnings()
      
      # input
      pub.source = docutils.io.StringInput(
          source=data, encoding=pub.settings.input_encoding)

      # output - not that it's needed
      pub.destination = docutils.io.StringOutput(
          encoding=pub.settings.output_encoding)
      
      # parse!
      document = pub.reader.read(pub.source, pub.parser, pub.settings)
      #warnings = ''.join(pub.settings.warning_stream.messages) #XXX what todo with this?
      
      # do the format
      instance.html = pub.writer.write(document, pub.destination)
      instance.text = data
